



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>pomelo生命周期回调和组件加入</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">pomelo生命周期回调和组件加入</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-18 06:01:12 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<h1>一 生命周期回调</h1>
<p>生命周期回调可以让开发人员在不同类型的server生命周期中进行详细操作。<br /><br />
提供的生命周期回调函数包含：beforeStartup，afterStartup，beforeShutdown，afterStartAll。<br /><br />
其详细的功能说明例如以下：</p>
<pre class="prettyprint linenums">beforeStartup(app, cb)<br />
before application start components callback<br />
Arguments<br />
app - application object<br />
cb - callback function

afterStartup(app, cb)<br />
after application start components callback<br />
Arguments<br />
app - application object<br />
cb - callback function

beforeShutdown(app, cb)<br />
before application stop components callback<br />
Arguments<br />
app - application object<br />
cb - callback function

afterStartAll(app)<br />
after all applications started callback<br />
Arguments<br />
app - application object</pre>
<p>详细用法：在game-server/app/servers/某一类型服务器/ 文件夹下加入lifecycle.js文件，详细文件内容例如以下：</p>
<pre class="prettyprint linenums">module.exports.beforeStartup = function(app, cb) {<br />
    // do some operations before application start up<br />
    cb();<br />
};

module.exports.afterStartup = function(app, cb) {<br />
    // do some operations after application start up<br />
    cb();<br />
};

module.exports.beforeShutdown = function(app, cb) {<br />
    // do some operations before application shutdown down<br />
    cb();<br />
};

module.exports.afterStartAll = function(app) {<br />
    // do some operations after all applications start up<br />
};</pre>

<h1>二 组件</h1>
<p>首先。在app/components/加入HelloWorld.js文件, 大致代码例如以下：</p>
<pre class="prettyprint linenums">// components/HelloWorld.js<br />
module.exports = function(app, opts) {<br />
  return new HelloWorld(app, opts);<br />
};

var HelloWorld = function(app, opts) {<br />
  this.app = app;<br />
  this.interval = opts.interval | DEFAULT_INTERVAL;<br />
};

HelloWorld.name = &#039;__HelloWorld__&#039;;

HelloWorld.prototype.start = function(cb) {<br />
  console.log(&#039;Hello World Start&#039;);<br />
  cb();<br />
}

HelloWorld.prototype.afterStart = function (cb) {<br />
  console.log(&#039;Hello World afterStart&#039;);<br />
  cb();<br />
}

HelloWorld.prototype.stop = function(force, cb) {<br />
  console.log(&#039;Hello World stop&#039;);<br />
  cb();<br />
}</pre>
<p>这样一个组件就创建完毕了。然后在app中配置。在masterserver中载入：</p>
<pre class="prettyprint linenums">var helloWorld = require(&#039;./app/components/HelloWorld&#039;);

app.configure(&#039;production|development&#039;, &#039;master&#039;, function() {<br />
  app.load(helloWorld, {interval: 5000});<br />
});</pre>

<h1>三 演示样例</h1>
<p>我这边是在arena服务中增加了lifecycle，同一时候加了一个组件，步骤例如以下。</p>
<h2>1 启动过程</h2>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20150623095256211?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQveHVmZW5nMDk5MQ==/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center"></p>
<p><img>
<p>watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQveHVmZW5nMDk5MQ==/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" alt=""&gt;</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20150623095351699?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQveHVmZW5nMDk5MQ==/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center"></p>
<h2>2 关闭过程</h2>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20150623095544592?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQveHVmZW5nMDk5MQ==/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center"><br>
</div>
<div><br>
</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20150623095559138?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQveHVmZW5nMDk5MQ==/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center"><br>
</div>
<div><br>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rql3xm1q.html">Divisors</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ozlk39.html">OK335xS tmp75 Qt 温度读取</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xkgdz8.html">【Java】理解 UDDI 注册中心的 WSDL</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vxodj8.html">Ubuntu安装google chrome过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pj36y8.html">BZOJ 1620&colon; &lbrack;Usaco2008 Nov&rsqb;Time Management 时间管理&lpar; 二分答案 &rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjwdoz8.html">Selenium chrome配置不加载图片Python版</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k6wo49.html">JFinal配合Shiro权限控制在FreeMarker模板引擎中控制到按钮粒度的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkv11e8.html">Aplcloud中 openFrame 和 openWin 的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv25vlo9.html">bootstrap 简单练习（后续把其它页面也进行练习）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwwx179.html">JavaScript变量转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o15315q.html">BeautifulSoup的基本用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvl35k8.html">P2626 斐波那契数列（升级版）（合数的质数分解， 大数为素数的概率十分小的利用）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1w615q.html">https协议的接口测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv70vj8.html">Leetcode&colon;LRU Cache&comma;LFU Cache</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5o1m7q.html">springboot 配置DRUID数据源</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2g13rq.html">【CJOJ2616】 【HZOI 2016】偏序 I（cdq分治，树状数组）</a>
		</li>
						<li><a href="https://www.batexi.com/a/902x34nq.html">启动memcached</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pp0key9.html">2017北京国庆刷题Day6 afternoon</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx20mnj8.html">c&num;基础   第一讲</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e04zxeq.html">Eclipse 中 SVN 提交过滤</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/ql1ylv69.html">java23种设计模式之一&colon; 代理模式&lpar;动态代理&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rnonzdq.html">清北学堂学习总结 day2 字符串 练习</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx21lnd8.html">uoj 41 【清华集训2014】矩阵变换 婚姻稳定问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mjgdnp8.html">hdu 5224 Tom and paper 水题</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gpl34l9.html">leetcode187&period; Repeated DNA Sequences</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdjm5x7q.html">linux基础命令学习 （十）Vi</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gpl3yz9.html">HP-unix如何生成动态库？</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ppzk7y9.html">When to use static method in a java class</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jmklje9.html">JSON还原为结构体</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvp6dxq.html">Android 工程报错解决 Unable to resolve target &amp;&num;39&semi;android-17&amp;&num;39&semi;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
